
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class News_article_symbolsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const news_article_symbols = await db.news_article_symbols.create(
            {
                id: data.id || undefined,
        
        relevance: data.relevance
        ||
        null
            ,
            
        sentiment_score: data.sentiment_score
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await news_article_symbols.setNews_article( data.news_article || null, {
            transaction,
        });
        
        await news_article_symbols.setMarket_symbol( data.market_symbol || null, {
            transaction,
        });
        

        

        

        return news_article_symbols;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const news_article_symbolsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                relevance: item.relevance
            ||
            null
            ,
            
                sentiment_score: item.sentiment_score
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const news_article_symbols = await db.news_article_symbols.bulkCreate(news_article_symbolsData, { transaction });

        // For each item created, replace relation files
        

        return news_article_symbols;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const news_article_symbols = await db.news_article_symbols.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.relevance !== undefined) updatePayload.relevance = data.relevance;
        
        
        if (data.sentiment_score !== undefined) updatePayload.sentiment_score = data.sentiment_score;
        
        
        updatePayload.updatedById = currentUser.id;

        await news_article_symbols.update(updatePayload, {transaction});

        
        
        if (data.news_article !== undefined) {
            await news_article_symbols.setNews_article(
              
              data.news_article,
              
              { transaction }
            );
        }
        
        if (data.market_symbol !== undefined) {
            await news_article_symbols.setMarket_symbol(
              
              data.market_symbol,
              
              { transaction }
            );
        }
        

        
        

        

        return news_article_symbols;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const news_article_symbols = await db.news_article_symbols.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of news_article_symbols) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of news_article_symbols) {
                await record.destroy({transaction});
            }
        });


        return news_article_symbols;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const news_article_symbols = await db.news_article_symbols.findByPk(id, options);

        await news_article_symbols.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await news_article_symbols.destroy({
            transaction
        });

        return news_article_symbols;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const news_article_symbols = await db.news_article_symbols.findOne(
            { where },
            { transaction },
        );

        if (!news_article_symbols) {
            return news_article_symbols;
        }

        const output = news_article_symbols.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.news_article = await news_article_symbols.getNews_article({
            transaction
        });
        
        
        output.market_symbol = await news_article_symbols.getMarket_symbol({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.news_articles,
        as: 'news_article',
        
        where: filter.news_article ? {
          [Op.or]: [
            { id: { [Op.in]: filter.news_article.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.news_article.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.market_symbols,
        as: 'market_symbol',
        
        where: filter.market_symbol ? {
          [Op.or]: [
            { id: { [Op.in]: filter.market_symbol.split('|').map(term => Utils.uuid(term)) } },
            {
              symbol: {
                [Op.or]: filter.market_symbol.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.sentiment_scoreRange) {
                const [start, end] = filter.sentiment_scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sentiment_score: {
                    ...where.sentiment_score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sentiment_score: {
                    ...where.sentiment_score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.relevance) {
                where = {
                    ...where,
                relevance: filter.relevance,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.news_article_symbols.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'news_article_symbols',
                        'relevance',
                        query,
                    ),
                ],
            };
        }

        const records = await db.news_article_symbols.findAll({
            attributes: [ 'id', 'relevance' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['relevance', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.relevance,
        }));
    }

    
};

